; Random Ninja
; 256b SID music
; This is a remix of the ending 
; "Last Ninja II - Central Park" of Matt Grey 
; in the remix version of Chris Holm

; this tune use voice 1 and 2 for music
; voice 3 is used for random number that change voice 1
; this make this tune quite different at each minute
; I listen to it for hours..... due to LN II magic sound

  processor 6502 
 
   org 2049

  .byte $0b,$08,$e8,$03,$9e,"2061",0,0,0

  .org 2061
  
  
point =   $84        ; +$85 pointer
patt     = $44       ; 4B index to current pattern

RDELAY = 9        ; reload delay         

; note declaration
G3  = 1
A3  = 2
C4  = 3
D4  = 4
E4  = 5
G4  = 6
      

;voice 2 should be like:
;$81 C8  
;$41 A8
;$40 00
; in goattracker format for the best drum effect. 

; voice 1 is
; $41 00
; $21 00
; in goattracker format


      ;stx  patt+7
      ;inx
      ;stx  delay                ; initial delay to virtually 0
      
      lda  #$8F                  ; voice 3 off
      sta  $D418                 ; volume max
      
      sei                        ; did not allow interrupt
      ;lda  #<irq
      ;sta  $0314
      ;lda  #>irq 
      ;sta  $0315             
      ;cli      
      ;rts
                                 ; don't use IRQ, as too many code is needed for making the dinamic
                                 ; waveform change at each tick
                                 ; this is best achieved with fake interrupt syncronizatin code         
  
;irq:                                 
      ;dec  delay      
      ;beq  music
      ;jmp  exit      

resetPat:      
      lda  $D41B                 ; "random" byte   
      lsr                        ; "random" bit 
      lda  #$11                  ; triangular waveform   
      bcs  skipAdd

      adc  #$10                  ; $21 waveform 
skipAdd:      
      sta  pos+1                 ; self modified code

      ldx  #0                    ; reset pattern 
      stx  patt            
music:      
        
      ldy  patt                  ; load pattern index of voices     
      cpy  #64
      beq  resetPat
      
nextInd:      
      iny                        ; increment index (so pattern must start one position before)
      sty  patt
                                 ; set pattern address         
      lda  #<(pat-1)
      sta  point
      lda  #>(pat-1)
      sta  point+1
      
      lda  (point),y             ; read current note/duration       
      bmi  voice2_note      
      bpl  newNote             
      
voice2_note:
      ldx  #157
      stx  $d400+7
      ldx  #69
      stx  $d401+7

      ;ldx  #$08
      ;stx  $D403+7              ; wave high      
      
      ldx  #$81
      stx  $D404+7               ; control voice 2   
      stx  $D404+14              ; control voice 3 (random number)   
      
      ;ldx  #$00                 ; we can skip this  
      ;stx  $D405+7              ; AD is already 0
      
      ldx  #$b8 ;e8
      stx  $D406+7               ; SR voice 2 
                   
newNote:     
      and  #$0F                  ; take only low nibble  
      beq  skipNew  
      tay
      
      lda  #00                   ; reset gate    
      sta  $D404      
                                 ; put right frequency
      lda  freqLo-1,y
      sta  $D400                 ; low voice 1 frequency   
      lda  freqHi-1,y
      sta  $D401                 ; high voice 1 frequency     
      sta  $D401+14              ; put even some frequency for the random number  
      
      lda  #$41
      sta  $D404                 ; voice 1 control             
      lda  #$76                  
      sta  $D405                 ; AD voice 1     
      sta  $D402                 ; wave low      
      lda  #$9B                      
      sta  $D406                 ; SR voice 1  
skipNew:                                                    

      ldx  #1
      jsr  fakeSyncro     
         
pos:      
      lda  #$21
      sta  $D404                  
      
      
      ;ldx  #196                 ; skip this for saving bytes: values is not so different
      ;stx  $d400+7
      ldx  #9
      stx  $d401+7               ; change only high frequency of voice 2     
            
      ;lda  #$41
      ;sta  $D404+7
      
      ldx  #2
      jsr  fakeSyncro        
      
      ;ldx  #113                 ; skip this for saving bytes: values is not so different
      ;stx  $d400+7        
      ldx  #2
      stx  $d401+7               ; change only high frequency of voice 2   
      ;lda  #$40
      ;sta  $D404+7
      
      
      ldx  #RDELAY
      jsr  fakeSyncro
      
      lda  #$09                  ; voice 2 hard restart
      sta  $D404+7
      

      jmp  music      
      
;================================
; A IRQ like syncronization
; we use a call to KERNAL delay
; for leave the (low) raster 0
;================================      
fakeSyncro:
      ;inc 53280                 ; this give some very good effect 
      lda  $D012            
      bne  fakeSyncro            ; sync with 0 of D012 (can come double in a frame)
      jsr  $eeb3                 ; some cycle of delay for skipping d012 to 0 
      dex
      bne  fakeSyncro     
      rts      
      
      
freqLo:
  .byte 10        ; G3
  .byte 162       ; A3
  .byte 103       ; C4
  .byte 137       ; D4  
  .byte 237       ; E4
  .byte 20        ; G4  

  
freqHi:
  .byte 13        ; G3 
  .byte 14        ; A3   
  .byte 17        ; C4
  .byte 19        ; D4   
  .byte 21        ; E4
  .byte 26        ; G4
  
      
; patterns
; $80=drum for voice 2   
; low byte=note for voice 1
pat:
  .byte $80+E4, 0, D4, $80, $80+G3, 0, $80+E4, 0
  .byte $80+D4, 0, G3, $80, $80+E4, 0, $80+D4, 0
  .byte $80+E4, 0, D4, $80, $80+A3, 0, $80+E4, 0
  .byte $80+D4, 0, $80+A3, $80, $80+E4, 0, $80+D4, $80
  
  .byte $80+E4, 0, C4, $80, $80+A3, 0, $80+E4, 0
  .byte $80+C4, 0, A3, $80, $80+E4, 0, $80+C4, 0
  .byte $80+E4, 0, C4, $80, $80+G3, 0, $80+E4, 0
  .byte $80+C4, 0, $80+G3, $80, $80+E4, 0, $80+C4, $80

  

      